package org.swtchart.util;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import java.util.SimpleTimeZone;
import java.util.TimeZone;
import java.util.Vector;

/**
 * ð  ƿƼ 
 *  
 * @author 	Sang-woog Kim
 * @since 	2004.12.08
 * @version 2004.12.08 Sang-woog Kim
 */
public class DateUtil {
	
	/**
	*	 ¥ yyyy MM dd HH mm ·  .
	*
	*	@return yyyy MM dd HH mm · ٲ  ð
	*/
	public static String getTime() {
		Date d = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy MM dd HH mm ss");
		return sdf.format(d);
	}

	/**
	*	 ¥ Է¹  · ȯϿ  ϵ Ѵ. 
	*	) format : yyyyMMddHHmmss --> 20031130124130   ȯ
	*/
	public static String getTime(String format) {
		Date d = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}
	
	/**
	*	Է¹ ¥ Է¹  · ȯϿ  ϵ Ѵ. 
	*	) format : yyyyMMddHHmmss --> 20031130124130   ȯ
	*/
	public static String getTime(String dateString, String format) {
		Calendar cal = getCalendar(dateString);
		Date d = cal.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}
	

	/**
	*	 ¥ yyyy/mm/dd · س.
	*
	*	@return yyyy/mm/dd· ǵ ڿ
	*/
	public static String getCurrentDate(){
		return getCurrentDate("yyyyMMdd");
	}

	/**
	*	 ¥ yyyy/mm/dd · س.
	*
	*	@return yyyy/mm/dd· ǵ ڿ
	*/
	public static String getCurrentDate(String format){
		Date d =new Date();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}

	/**
	*	  ⵵ Բ س.
	*
	*	@return yyyy/mm· ǵ ڿ
	*/
	public static String getThisMonth(){
		Date d =new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM");
		return sdf.format(d);
	}

	/**
	*	 ⵵ س.
	*
	*	@return yyyy· ǵ ڿ
	*/
	public static String getThisYear(){
		Date d =new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy");
		return sdf.format(d);
	}

	/**
	*	 ð 03:34  / ǥѴ.
	*
	*	@return hh:mm· ǵ ڿ
	*/
	public static String getCurrentTime(){
		Date d =new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("HHmmss");
		return sdf.format(d);
	}


	/**
	*	  Է¹  ¥ ˾Ƴ
	*
	*	@return yyyy/mm/dd· ǵ ڿ
	*/
	public static String getDayInterval(String format, int distance){
		Calendar cal = getCalendar();
		cal.roll(Calendar.DATE , distance);
		Date d = cal.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}

	/**
	*	Է¹  ¥  ش ų ̷ ˾Ƴ
	*
	*	@return format· ǵ ڿ
	*/
	public static String getDayInterval(String dateString, String format, int distance){
		Calendar cal = getCalendar(dateString);
		cal.roll(Calendar.DATE , distance);
		Date d = cal.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}

	/**
	*	   ¥ ˾Ƴ
	*
	*	@return yyyy/mm/dd· ǵ ڿ
	*/
	public static String getYesterday(){
		Calendar cal = getCalendar();
		cal.roll(Calendar.DATE , -1);
		Date d = cal.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
		return sdf.format(d);
	}

	/**
	*	  ¥   ˾Ƴ.
	*
	*	@return yyyy/mm· ǵ ڿ
	*/
	public static String getLastMonth(){
		Calendar cal = getCalendar();
		cal.roll(Calendar.MONTH , -1);
		Date d = cal.getTime();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM");
		return sdf.format(d);
	}

	/**
	*	־ ϰ Ͽ    迭 .
	*
	*	@param startDay	ϰ ϴ  
	*	@param endDay	ϰ ϴ  
	*	@return ϰ ϻ ¥  ڿ迭
	*/
	public static String[] getDates(String startDay, String endDay){
		Vector v = new Vector();
		v.addElement(startDay);
		Calendar cal = getCalendar();
		cal.setTime(string2Date(startDay));

		String nextDay = date2String(cal.getTime());

		while(!nextDay.equals(endDay)){
			cal.add(Calendar.DATE,1);
			nextDay = date2String(cal.getTime());
			v.addElement(nextDay);
		}

		String[] go = new String[v.size()];
		v.copyInto(go);
		return go;
	}

	/**
	*	GMTؽð ѱǥؽø ȯѴ. 
	*
	*	return GMT+09:00 ѹαǥؽ
	*/
	public static Calendar getCalendar(){
		Calendar calendar =
        new GregorianCalendar(
            TimeZone.getTimeZone("GMT+09:00"),Locale.KOREA);
    	calendar.setTime (new Date());

    	return calendar;
	}

	/**
	*	GMTؽð ѱǥؽø ȯѴ. 
	*
	*	return GMT+09:00 ѹαǥؽ
	*/
	public static Calendar getCalendar(String dateString){
		Calendar calendar =
        new GregorianCalendar(
            TimeZone.getTimeZone("GMT+09:00"),Locale.KOREA);
    	calendar.setTime (string2Date(dateString, "yyyyMMdd"));

    	return calendar;
	}

	/**
	*	GMTؽð ѱǥؽø ȯѴ. 
	*
	*	return GMT+09:00 ѹαǥؽ
	*/
	public static Calendar getCalendar(Date date){
		Calendar calendar =
        new GregorianCalendar(
            TimeZone.getTimeZone("GMT+09:00"),Locale.KOREA);
    	calendar.setTime(date);

    	return calendar;
	}

	/**
	* ¥ ͸ yyyy/mm/dd· ٲִ ޼ҵ
	* Date -> String (2000/09/25)
	*
	*	@param	d	 ¥ǥ·  dateü
	*	@return	yyyy/mm/dd· Ǿ ڿ
	*/
	public static String date2String(java.util.Date d){
		return date2String(d, "yyyyMMdd");
	}

	/**
	* ¥ ͸ · ٲִ ޼ҵ
	* Date -> String (2000/09/25)
	*
	*	@param	d	 ¥ǥ·  dateü
	*	@return	yyyy/mm/dd· Ǿ ڿ
	*/
	public static String date2String(java.util.Date d, String format){
		SimpleDateFormat sdf = new SimpleDateFormat(format);
		return sdf.format(d);
	}

	/**
	* ڿ ͸ yyyy/mm/dd Date ü ٲپش
	* String -> Date (2000/09/25)
	*
	*	@param	s	Date·   yyyy/mm/dd ڿ
	*	@return	yyyy/mm/dd· Ǿ Dateü
	*/
	public static java.util.Date string2Date(String s){
		return string2Date(s, "yyyy/MM/dd");
	}

	/**
	* ڿ ͸  Date ü ٲپش
	* String -> Date (2000/09/25)
	*
	*	@param	s	Date·   yyyy/mm/dd ڿ
	*	@return	yyyy/mm/dd· Ǿ Dateü
	*/
	public static java.util.Date string2Date(String s, String format){
		java.util.Date d = null;
		try{
			SimpleDateFormat sdf = new SimpleDateFormat(format);
			d = sdf.parse(s , new ParsePosition(0) );
		}catch(Exception e){throw new RuntimeException("Date format not valid.");}
		return d;
	}

	/**  
	*	 ¥  
	*
	*  @param startDate  ¥
	*  @param endDate    ¥
	*  @return long     ¥ 
   */
    public static long getDayDistance( String startDate, 
                                String endDate ) throws Exception{
       return getDayDistance(startDate, endDate, null);
    }

    /**
     *  ¥  
     * @param startDate	۳¥
     * @param endDate	ᳯ¥
     * @param format	¥
     * @return long		¥
     * @throws Exception
     */
    public static long getDayDistance( String startDate, 
                                String endDate, 
                                String format    ) throws Exception{
        if (format == null) 
            format = "yyyyMMdd";
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        Date sDate;
        Date eDate;
        long day2day = 0;
        try {
            sDate = sdf.parse(startDate);
            eDate = sdf.parse(endDate);
            day2day = (eDate.getTime() - sDate.getTime()) / (1000*60*60*24);
        } catch(Exception e) {
            throw new Exception("wrong format string");
        }

        return Math.abs(day2day);
    }


    /**
     * ̱ ð (EEE, d MMM yyyy HH:mm:ss z)
     * @return ð ڿ(̱ǥ)
     */
	public static String getUSTime() {
		Date d = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss z", Locale.US);
		sdf.setTimeZone((new SimpleTimeZone(0, "GMT")));
		return sdf.format(d);
	}

	public static String getUSTimeDefaultZone() {
		Date d = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss z", Locale.US);
		//sdf.setTimeZone((new SimpleTimeZone(0, "GMT")));
		return sdf.format(d);
	}
	
	/**
	 *  ð ʸ ؼ Date Ѵ.
	 * @param n 	 
	 * @return 		 Date
	 */
	public static Date addSecond(int n) {
		Calendar c = getCalendar();
		c.add(Calendar.SECOND, n);
		Date d = c.getTime();
		return d;
	}


	/**
	 * ð  ؼ Date Ѵ.
	 * @param n 	 
	 * @return 		Date
	 */
	public static Date addMinute(int n) {
		Calendar c = getCalendar();
		c.add(Calendar.MINUTE, n);
		Date d = c.getTime();
		return d;
	}


	/**
	 *  ð String longŸ ȯ
	 * 
	 * @param strTime
	 * @return
	 */
	public static long timeToLong(String strTime) {
		long time = 0;
		byte tCount = 0;
		String token = "";
		char c;
		int tTime;
		for (int i = 0; i < strTime.length(); i++) {
			c = strTime.charAt(i);
			if (c == ':' || c == '.') {
				tTime = Integer.parseInt(token);
				if (tCount == 0)
					time += tTime * 60 * 60 * 1000;
				else if (tCount == 1)
					time += tTime * 60 * 1000;
				else if (tCount == 2)
					time += tTime * 1000;
				//else if(tCount == 3) time += tTime;
				tCount++;
				token = "";
			} else
				token += c;
		}
		tTime = Integer.parseInt(token);
		time += tTime;
		return time;
	}	
	
}
