package org.swtchart.data;

import java.util.Random;

import junit.framework.TestCase;

public class TimeChartDataTest extends TestCase {

	public void testBasicInsertData() {

		TimeChartData chartData = new TimeChartData();

		Random rnd = new Random(100);

		double first = 0.0;
		double last = 0.0;
		final int LOOP_SIZE = 10;

		for (int i = 0; i < LOOP_SIZE; i++) {
			double value = rnd.nextDouble();
			chartData.add(value);
			if (i == 0) {
				first = value;
			} else if (i == LOOP_SIZE - 1) {
				last = value;
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

		assertEquals(LOOP_SIZE, chartData.size());

		assertEquals(chartData.get(0).getValue(), first);

		assertEquals(chartData.get(LOOP_SIZE - 1).getValue(), last);

	}

	public void testSetMaxSize() {

		final int MAX_SIZE = 10;
		final int OVER = 2;

		TimeChartData chartData = new TimeChartData(MAX_SIZE);

		Random rnd = new Random(100);

		double first = 0.0;
		double last = 0.0;

		for (int i = 0; i < MAX_SIZE + OVER; i++) {
			double value = rnd.nextDouble();
			chartData.add(value);
			if (OVER == i) {
				first = value;
			}
			if ((MAX_SIZE + OVER - 1) == i) {
				last = value;
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		assertEquals(MAX_SIZE, chartData.size());

		assertEquals(chartData.get(0).getValue(), first);

		assertEquals(chartData.get(MAX_SIZE - 1).getValue(), last);

	}

}
